#ifndef _KSS_H_
#define _KSS_H_

#include <X11/Xmd.h>
#include "list.h"

#define KSS_EXTENSION_NAME KSS_NAME
#define XKSSExtensionName KSS_NAME
#define KSS_NAME "KSS"

#define KssScreenshotNotify 0

typedef struct {
    unsigned long id;
    unsigned long pid;
    struct xorg_list list;
} Kscreenshot;

extern Kscreenshot *kss;

typedef struct {
    unsigned long pid;
    struct xorg_list list;
} KscFullscreen;

extern KscFullscreen *kscfull;

enum {
    X_KSSScreenshot = 0,
    X_KSSSensitivequery,
    X_KSSReqCount,
};

extern int kss_extension;

typedef struct {
    CARD8 reqType;
    CARD8 kssReqType;
    CARD16 length;
    CARD16 pid;
    CARD8 flag;
    CARD64 window;
    CARD8 pad1;
} xKSSScreenshotReq;
#define sz_xKSSScreenshotReq 16
typedef struct {
    BYTE type;                          /* X_Reply */
    BYTE pad1;
    CARD16 sequenceNumber;
    CARD32 length;
    CARD32 ret;
    CARD32 pad3;
    CARD32 pad4;
    CARD32 pad5;
    CARD32 pad6;
    CARD32 pad7;
} xKSSScreenshotReply;
#define sz_xKSSScreenshotReply 32

typedef struct {
    CARD8 reqType;
    CARD8 kssReqType;
    CARD16 length;
    CARD64 window;
} xKSSSensitivequeryReq;
#define sz_xKSSSensitivequeryReq 12
typedef struct {
    BYTE type;
    BYTE pad1;
    CARD16 sequenceNumber;
    CARD32 length;
    CARD32 ret;
    CARD32 pad2;
    CARD32 pad3;
    CARD32 pad4;
    CARD32 pad5;
    CARD32 pad6;
} xKSSSensitivequeryReply;
#define sz_xKSSSensitivequeryReply 32

typedef struct {
    CARD8 type;
    CARD8 extension;
    CARD16 sequenceNumber;
    CARD32 length;
    CARD16 evtype;
    CARD16 pad2;
    CARD32 window;
    CARD32 pad4;
    CARD32 pad5;
    CARD32 pad6;
    CARD32 pad7;
} xKSSScreenshotNotify;
#define sz_xKSSScreenshotNotify 32

#endif
